import { world } from "@minecraft/server";
import en_US from "../Data/Languages/en_US";
import { c } from "./Util";
import zh_TW from "../Data/Languages/zh_TW";
import ar from "../Data/Languages/ar";
import zh_CN from "../Data/Languages/zh_CN";
import vi_VN from "../Data/Languages/vi_VN";
// declare the dynamic language
let languageNow = c().language;
export const getLang = () => languageNow;
// All language exporter
export const langs = {
    "en_US": en_US,
    "zh_TW": zh_TW,
    "zh_CN": zh_CN,
    "ar": ar,
    "vi_VN": vi_VN,
};
// when world initialized, update the language
world.afterEvents.worldInitialize.subscribe(() => {
    const language = world.getDynamicProperty("matrix:language");
    if (language === undefined)
        return;
    else if (!Object.keys(langs).includes(language))
        return world.setDynamicProperty("matrix:language", undefined);
    else
        languageNow = language;
});
export function changeLanguage(lang) {
    if (Object.keys(langs).includes(lang)) {
        languageNow = lang;
        world.setDynamicProperty("matrix:language", lang);
        return true;
    }
    return false;
}
export const getAllLang = () => Object.keys(langs);
export default (key) => langs[languageNow][key] ?? "[???]";
